'Raybot Graphics Demo (C) Copyright 2009 Rayslogic.com, LLC
'Version 1.0a
'The Propeller Graphics Demo adapted for a 3.5" TFT Screen
'This is basically a copy of the PTP example with some changes to the driver for the changes in pin usage
'MIT License

CON

  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000


  'LCD is 320x240 giving 20x15 tiles
  cols = 20
  rows = 15
  screensize = cols * rows

CON  'Constants for Graphics Demo 
  _stack = ($3000 + $3000 + 200+2*screensize) >> 2   'accomodate display memory and stack  
  x_tiles = 16
  y_tiles = 12

  paramcount = 14  
  bitmap_base = $2000
  display_base = $5000

  lines = 5
  thickness = 2

  GraphicsXOffset=2
  GraphicsYOffset=2

VAR

  long  lcd_status      'status: off/visible/invisible  read-only       (5 contiguous longs)
  long  lcd_enable      'enable: off/on                 write-only
  long  lcd_videobase   'video base @word               write-only
  long  lcd_colorbase   'color base @long               write-only
  long  lcd_backlight   'Used to control LCD backlight

  word  screen[screensize]
  long  col, row, color
  long  boxcolor,ptr

  byte  x[lines]
  byte  y[lines]
  byte  xs[lines]
  byte  ys[lines]

var 'vars for Graphics Demo
  long  mousex, mousey   



OBJ    'Objects for Graphics Demo
  'mouse : "mouse"
  gr    : "graphics"

OBJ

  lcd : "RayBot_LcdDriver"  'Modified to drive 3.5" TFT    

pub Main
  'Start up Display
  'clear screen
  print($100)
  'start driver
  lcd_enable:=1
  lcd_videobase := @screen
  lcd_colorbase := @vgacolors
  lcd_backlight:=1  '1=bright, 16=medium, 32=dark
  lcd.start(@lcd_status)
  col:=3
  PrintStr(string("Graphics Demo!"))

  waitcnt(cnt+clkfreq)

  GraphicsDemo


PUB GraphicsDemo|i,j,k,dx,dy, kk, pp, pq, rr, numx, numchr,GraphicsColor 
  'init colors
  GraphicsColor:=16 'Using this color for graphics colors
  'Trying to sorta match the color gradient in the real version...
  vgacolors[GraphicsColor+0]:= $0CFC0000+%%0210_0000
  vgacolors[GraphicsColor+1]:= $0CFC0000+%%0210_0000  
  vgacolors[GraphicsColor+2]:= $0CFC0000+%%0210_0000  
  vgacolors[GraphicsColor+3]:= $0CFC0000+%%1210_0000  
  vgacolors[GraphicsColor+4]:= $0CFC0000+%%1220_0000     
  vgacolors[GraphicsColor+5]:= $0CFC0000+%%1220_0000  
  vgacolors[GraphicsColor+6]:= $0CFC0000+%%1120_0000  
  vgacolors[GraphicsColor+7]:= $0CFC0000+%%2120_0000  
  vgacolors[GraphicsColor+8]:= $0CFC0000+%%2130_0000  
  vgacolors[GraphicsColor+9]:= $0CFC0000+%%2030_0000  
  vgacolors[GraphicsColor+10]:=$0CFC0000+%%3030_0000  
  vgacolors[GraphicsColor+11]:=$0CFC0000+%%3030_0000

  i:= GraphicsColor
  'Trying to sorta match the color gradient in the real version...
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%000_101_01<<8) '$0CFC0000+%%0210_0000
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%000_101_01<<8) '$0CFC0000+%%0210_0000  
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%001_100_01<<8) '$0CFC0000+%%0210_0000  
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%010_100_01<<8) '$0CFC0000+%%1210_0000  
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%010_100_10<<8) '$0CFC0000+%%1220_0000     
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%011_011_10<<8) '$0CFC0000+%%1220_0000  
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%011_011_10<<8) '$0CFC0000+%%1120_0000  
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%100_010_10<<8) '$0CFC0000+%%2120_0000  
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%101_010_11<<8) '$0CFC0000+%%2130_0000  
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%101_001_11<<8) '$0CFC0000+%%2030_0000  
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%110_001_11<<8) '$0CFC0000+%%3030_0000  
  vgacolors[i++]:= constant($C0<<24+$FF<<16 +%110_000_11<<8) '$0CFC0000+%%3030_0000    

  'init tile screen
  repeat dx from 0 to x_tiles - 1
    repeat dy from 0 to y_tiles - 1
      screen[(dy+GraphicsYOffset) * cols + dx+GraphicsXOffset]:= display_base >> 6 + dy + dx * y_tiles +(GraphicsColor+dy)<<10'((GraphicsColor+dy) & $3F)<<10



  'init bouncing lines
  i := 1001
  j := 123123
  k := 8776434
  repeat i from 0 to lines - 1
    x[i] := ?j // 64
    y[i] := k? // 48
    repeat until xs[i] := k? ~> 29
    repeat until ys[i] := ?j ~> 29


  'mouse.start(0,1)

  
  'start and setup graphics
  gr.start


  gr.setup(16, 12, 128, 96, bitmap_base)

  'start mouse
  'mouse.start(4, 5)'(24, 25)


  repeat

    'clear bitmap
    gr.clear


    'draw spinning triangles
    gr.colorwidth(3,0)
    repeat i from 1 to 8
      gr.vec(0, 0, (k & $7F) << 3 + i << 5, k << 6 + i << 8, @vecdef)

    'draw expanding mouse crosshairs
    gr.colorwidth(2,k>>2)
   ' mousex := mousex + mouse.delta_x #> -128 <# 127
   ' mousey := mousey + mouse.delta_y #> -96 <# 95
    'gr.pix(mousex, mousey, k>>4 & $7, @pixdef)

    'if left mouse button pressed, throw snowballs
    if false'mouse.button(0)
      gr.width(pq & $F)
      gr.color(2)
      pp := (pq & $F)*(pq & $F) + 5
      pq++
      gr.arc(mousex, mousey, pp, pp>>1, -k * 200, $200, 8, 0)
    else
      pq~

    'if right mouse button pressed, pause
    'repeat while mouse.button(1)

    'draw expanding pixel halo
    gr.colorwidth(1,k)
    gr.arc(0,0,80,30,-k<<5,$2000/9,9,0)
    
    'step bouncing lines
    repeat i from 0 to lines - 1
      if ||~x[i] > 60
        -xs[i]
      if ||~y[i] > 40
        -ys[i]
      x[i] += xs[i]
      y[i] += ys[i]

    'draw bouncing lines
    gr.colorwidth(1,thickness)
    gr.plot(~x[0], ~y[0])
    repeat i from 1 to lines - 1
      gr.line(~x[i],~y[i])
    gr.line(~x[0], ~y[0])

    'draw spinning stars and revolving crosshairs and dogs
    gr.colorwidth(2,0)
    repeat i from 0 to 7
      gr.vecarc(80,50,30,30,-(i<<10+k<<6),$40,-(k<<7),@vecdef2)
      gr.pixarc(-80,-40,30,30,i<<10+k<<6,0,@pixdef2)
      gr.pixarc(-80,-40,20,20,-(i<<10+k<<6),0,@pixdef)

    'draw small box with text
    gr.colorwidth(1,14)
    gr.box(60,-80,60,16)  
    gr.textmode(1,1,6,5)
    gr.colorwidth(2,0)
    gr.text(90,-72,@pchip)
    
    'draw incrementing digit
    if not ++numx & 7
      numchr++
    if numchr < "0" or numchr > "9"
      numchr := "0"
    gr.textmode(8,8,6,5)
    gr.colorwidth(1,8)
    gr.text(-90,50,@numchr)
 
    'copy bitmap to display
    gr.copy(display_base)

    'increment counter that makes everything change
    k++


    
{
PUB box(left,top,width,height) | x, y, i          

  ptr := top * cols + left
  boxchr($0)
  repeat i from 1 to width
    boxchr($C)
  boxchr($8)
  repeat i from 1 to height
    ptr := (top + i) * cols + left
    boxchr($A)
    ptr += width
    boxchr($B)
  ptr := (top + height + 1) * cols + left
  boxchr($1)
  repeat i from 1 to width
    boxchr($D)
  boxchr($9)

PRI boxchr(c): i

  screen[ptr++] := boxcolor << 10 + $200 + c

  

'' Print a character
''
''  $00..$FF = character
''      $100 = clear screen
''      $108 = backspace
''      $10D = new line
''$110..$11F = select color
}

PRI PrintStr(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    print(byte[stringptr++])

PUB print(c) | i, k

  case c
    $00..$FF:           'character?
      k := color << 1 + c & 1
      i := k << 10 + $200 + c & $FE
      screen[row * cols + col] := i
      screen[(row + 1) * cols + col] := i | 1
      if ++col == cols
        newline

    $100:               'clear screen?
      wordfill(@screen, $220, screensize)
      col := row := 0
      color:=0

    $108:               'backspace?
      if col
        col--

    $10D:               'return?
      newline

    $110..$11F:         'select color?
      color := c & $F


' New line

PRI newline : i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
'      wordmove(@screen[i*cols], @screen[(i+2)*cols], cols)
    'clear new line
'    wordfill(@screen[(rows-2)*cols], $200, cols<<1)


' Data

DAT

vgacolors               long
                        long    $FC01FC01'$F00CF00C       'blue background with yellow letters
                        long    $FCFC0101'$F0F00C0C
                        long    $08A808A8       'green
                        long    $0808A8A8
                        long    $50005000       'blue
                        long    $50500000
                        long    $FC00FC00       'white
                        long    $FCFC0000
                        long    $FF80FF80       'red/white
                        long    $FFFF8080
                        long    $FF20FF20       'green/white
                        long    $FFFF2020
                        long    $FF28FF28       'cyan/white
                        long    $FFFF2828
                        long    $00A800A8       'grey/black
                        long    $0000A8A8
                        long    $0CFCC000      'Colors for Graphics
spcl                    long    $30100020       'greenbox
                        long    $3C142828       'cyanbox
                        long    $FC54A8A8       'greybox
                        long    $3C14FF28       'cyanbox+underscore
                        long    0 [16]

DAT 'data for Graphics_Demo

vecdef                  word    $4000+$2000/3*0         'triangle
                        word    50
                        word    $8000+$2000/3*1+1
                        word    50
                        word    $8000+$2000/3*2-1
                        word    50
                        word    $8000+$2000/3*0
                        word    50
                        word    0

vecdef2                 word    $4000+$2000/12*0        'star
                        word    50
                        word    $8000+$2000/12*1
                        word    20
                        word    $8000+$2000/12*2
                        word    50
                        word    $8000+$2000/12*3
                        word    20
                        word    $8000+$2000/12*4
                        word    50
                        word    $8000+$2000/12*5
                        word    20
                        word    $8000+$2000/12*6
                        word    50
                        word    $8000+$2000/12*7
                        word    20
                        word    $8000+$2000/12*8
                        word    50
                        word    $8000+$2000/12*9
                        word    20
                        word    $8000+$2000/12*10
                        word    50
                        word    $8000+$2000/12*11
                        word    20
                        word    $8000+$2000/12*0
                        word    50
                        word    0

pixdef                  word                            'crosshair
                        byte    2,7,3,3
                        word    %%00333000,%%00000000
                        word    %%03020300,%%00000000
                        word    %%30020030,%%00000000
                        word    %%32222230,%%00000000
                        word    %%30020030,%%02000000
                        word    %%03020300,%%22200000
                        word    %%00333000,%%02000000

pixdef2                 word                            'dog
                        byte    1,4,0,3
                        word    %%20000022
                        word    %%02222222
                        word    %%02222200
                        word    %%02000200

pchip                   byte    "Propeller",0           'text